Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/SWTChartsComponentsProvider.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/SWTChartsComponentsProvider.java	(revision 1334)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/SWTChartsComponentsProvider.java	(revision 1335)
@@ -1,1028 +1,1027 @@
-package org.txm.chartsengine.rcp;
-
-
-import java.awt.Color;
-import java.awt.event.FocusEvent;
-import java.awt.event.FocusListener;
-import java.awt.event.MouseEvent;
-import java.awt.event.MouseListener;
-import java.awt.event.MouseMotionListener;
-import java.io.File;
-import java.util.ArrayList;
-import java.util.Arrays;
-import java.util.List;
-import java.util.Properties;
-
-import javax.swing.JComponent;
-import javax.swing.border.LineBorder;
-
-import org.eclipse.core.commands.ExecutionEvent;
-import org.eclipse.core.runtime.CoreException;
-import org.eclipse.core.runtime.IConfigurationElement;
-import org.eclipse.core.runtime.Platform;
-import org.eclipse.jface.preference.BooleanFieldEditor;
-import org.eclipse.jface.preference.ComboFieldEditor;
-import org.eclipse.swt.SWT;
-import org.eclipse.swt.graphics.Point;
-import org.eclipse.swt.layout.GridData;
-import org.eclipse.swt.widgets.Composite;
-import org.eclipse.swt.widgets.Display;
-import org.eclipse.swt.widgets.Event;
-import org.eclipse.swt.widgets.Group;
-import org.eclipse.swt.widgets.Label;
-import org.eclipse.swt.widgets.Listener;
-import org.eclipse.swt.widgets.TabFolder;
-import org.eclipse.swt.widgets.TabItem;
-import org.eclipse.swt.widgets.ToolBar;
-import org.eclipse.swt.widgets.ToolItem;
-import org.eclipse.swt.widgets.Widget;
-import org.eclipse.ui.IWorkbenchPage;
-import org.eclipse.ui.IWorkbenchWindow;
-import org.eclipse.ui.PartInitException;
-import org.eclipse.ui.PlatformUI;
-import org.eclipse.ui.contexts.IContextService;
-import org.eclipse.ui.part.MultiPageEditorPart;
-import org.txm.chartsengine.core.ChartsEngine;
-import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
-import org.txm.chartsengine.core.results.ChartResult;
-import org.txm.chartsengine.rcp.editors.ChartEditor;
-import org.txm.chartsengine.rcp.editors.ChartEditorInput;
-import org.txm.chartsengine.rcp.events.EventCallBack;
-import org.txm.chartsengine.rcp.messages.SWTComponentsProviderMessages;
-import org.txm.chartsengine.rcp.preferences.___KeyboardBindingProperties;
-import org.txm.chartsengine.rcp.preferences.___MouseBindingProperties;
-import org.txm.chartsengine.rcp.swt.AdvancedChartEditorToolBar;
-import org.txm.chartsengine.rcp.swt.ChartComposite;
-import org.txm.chartsengine.rcp.swt.ChartEditorToolBar;
-import org.txm.core.preferences.TXMPreferences;
-import org.txm.rcp.editors.SplitedGenericMultiPageEditor;
-import org.txm.rcp.preferences.TXMPreferencePage;
-import org.txm.rcp.preferences.TXMPreferenceStore;
-import org.txm.utils.logger.Log;
-
-/**
- * A class providing EditorPart and EditorInput according to the current charts engine.
- * @author sjacquot
- * 
- */
-public abstract class SWTChartsComponentsProvider {
-
-	
-	
-	
-	
-	// FIXME: should be done in an activator?
-	static	{
-		// Initializes the SWT Charts Components provider according to the current charts engine and its output format
-		SWTChartsComponentsProvider.createSWTChartsComponentsProviders();
-		SWTChartsComponentsProvider.setCurrrentComponentsProvider(ChartsEngine.getCurrent());
-	}
-	
-	
-	
-	
-	
-	/**
-	 * The charts engine.
-	 */
-	protected ChartsEngine chartsEngine;
-
-
-	/**
-	 * The name of the provider.
-	 */
-	protected String name;
-	
-	/**
-	 * The supported editor input formats.
-	 */
-	protected List<String> supportedInputFormats;
-	
-	
-	/**
-	 * Mouse control properties which will be shared by all implementations and chart editors.
-	 */
-	protected Properties mouseBindingProperties;
-
-
-	/**
-	 * Keyboard control properties which will be shared by all implementations and chart editors.
-	 */
-	protected Properties keyboardBindingProperties;
-
-	
-	/**
-	 * Installed SWT charts components providers.
-	 */
-	protected static ArrayList<SWTChartsComponentsProvider> chartsComponentsProviders;
-	
-	/**
-	 * Current SWT charts components provider index in the providers list.
-	 */
-	protected static int currentChartsComponentsProviderIndex;
-	
-	
-	
-	public SWTChartsComponentsProvider(ChartsEngine chartsEngine, Properties mouseBindingProperties, Properties keyboardBindingProperties) {
-		this.chartsEngine = chartsEngine;
-
-		this.mouseBindingProperties = mouseBindingProperties;
-		this.keyboardBindingProperties = keyboardBindingProperties;
-
-		// FIXME : see if we need to define the L&F as system for AWT/Swing components
-		// If yes, we need to find a way to manage the GTK L&F/Linux bug, see ticket #761
-        // System Look and feel
-//        try {
-//			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
-//		}
-//		catch(ClassNotFoundException e) {
-//			// TODO Auto-generated catch block
-//			e.printStackTrace();
-//		}
-//		catch(InstantiationException e) {
-//			// TODO Auto-generated catch block
-//			e.printStackTrace();
-//		}
-//		catch(IllegalAccessException e) {
-//			// TODO Auto-generated catch block
-//			e.printStackTrace();
-//		}
-//		catch(UnsupportedLookAndFeelException e) {
-//			// TODO Auto-generated catch block
-//			e.printStackTrace();
-//		}
-	}
-
-	/**
-	 * 
-	 * @param chartsEngine
-	 */
-	public SWTChartsComponentsProvider(ChartsEngine chartsEngine) {
-		this(chartsEngine, new ___MouseBindingProperties(), new ___KeyboardBindingProperties());
-	}
-
-	
-	/**
-	 * 
-	 */
-	public SWTChartsComponentsProvider() {
-		this(null);
-	}
-
-	
-	/**
-	 * Creates a <code>ChartEditorInput</code> for the specified chart result.
-	 * @param result
-	 * @return a <code>ChartEditorInput</code>
-	 */
-	public ChartEditorInput createChartEditorInput(ChartResult result) {
-		return new ChartEditorInput(this, result);
-	}
-	
-	/**
-	 * Creates a new chart container for the specified <code>ChartResult</code> save it in the specified <code>ChartEditorInput</code>.
-	 * 
-	 * @param chartsEngine
-	 * @param chartEditorInput
-	 * @param result
-	 * @param preferencesNode
-	 * @param chartType
-	 * @return
-	 */
-	protected abstract boolean createChartContainer(ChartsEngine chartsEngine, ChartEditorInput chartEditorInput);
-	
-	/**
-	 * Creates a new chart container for the specified <code>ChartResult</code> save it in the specified <code>ChartEditorInput</code>.
-	 * 
-	 * @param chartEditorInput
-	 * @param result
-	 * @param preferencesNode
-	 * @param chartType
-	 * @return
-	 */
-	public boolean createChartContainer(ChartEditorInput chartEditorInput)	{
-		Log.finest(this.getClass().getName() + ": creating a chart container...");
-		return this.createChartContainer(this.getChartsEngine(), chartEditorInput);
-	}
-	
-	
-	/**
-	 * Creates and stores SWT charts components providers from installed extension contributions and define the current one according to the specified charts engine output format and provider supported input format.
-	 */
-	public static void createSWTChartsComponentsProviders()	{
-		
-		
-		SWTChartsComponentsProvider.chartsComponentsProviders = new ArrayList<SWTChartsComponentsProvider>();
-		
-		String extensionPointId = "org.txm.rcp.swtchartscomponentsprovider"; //$NON-NLS-1$
-		IConfigurationElement[] contributions = Platform.getExtensionRegistry().getConfigurationElementsFor(extensionPointId);
-		
-		for(int i = 0; i < contributions.length; i++) {
-			
-			// FIXME: to manage more than one input format, Store them in the class rather than in the extension schema?
-			String formatsStr = contributions[i].getAttribute("inputFormat").replace(" ", "").trim();
-			String[] formats = formatsStr.split(",");
-			
-			try {
-				SWTChartsComponentsProvider swtChartsComponentsProvider = (SWTChartsComponentsProvider)contributions[i].createExecutableExtension("class");  //$NON-NLS-1$
-				swtChartsComponentsProvider.setName(contributions[i].getAttribute("name")); //$NON-NLS-1$
-				swtChartsComponentsProvider.setEditorSupportedInputFormat(Arrays.asList(formats));
-				
-				// Add the first charts engine that supports the input format
-				ChartsEngine chartsEngine = null;
-				for(int j = 0; j < formats.length; j++) {
-					chartsEngine = ChartsEngine.getChartsEngine(formats[j]);
-					if(chartsEngine != null)	{
-						break;
-					}
-				}
-				swtChartsComponentsProvider.setChartsEngine(chartsEngine);					
-				
-				SWTChartsComponentsProvider.chartsComponentsProviders.add(swtChartsComponentsProvider);
-				Log.warning("Starting SWT charts components provider: " + swtChartsComponentsProvider + ".");
-				
-				
-			}
-			catch(CoreException e) {
-				// TODO Auto-generated catch block
-				e.printStackTrace();
-			}
-		}
-	}
-	
-	
-	/**
-	 * Gets the current charts component provider.
-	 * @return the current charts engine
-	 */
-	public static SWTChartsComponentsProvider getCurrent()	{
-		return SWTChartsComponentsProvider.chartsComponentsProviders.get(SWTChartsComponentsProvider.currentChartsComponentsProviderIndex);
-	}
-	
-	/**
-	 * Sets the current charts component provider according to the specified charts engine output format and provider supported input format. 
-	 * @param name the name of the charts engine to set as current
-	 */
-	public static void setCurrrentComponentsProvider(ChartsEngine chartsEngine)	{
-		for(int i = 0; i < SWTChartsComponentsProvider.chartsComponentsProviders.size(); i++) {
-			if(SWTChartsComponentsProvider.chartsComponentsProviders.get(i).getEditorSupportedInputFormats().contains(chartsEngine.getOutputFormat()))	{
-				// Set new charts engine
-				SWTChartsComponentsProvider.chartsComponentsProviders.get(i).setChartsEngine(chartsEngine);
-				
-				SWTChartsComponentsProvider.currentChartsComponentsProviderIndex = i;
-				Log.finest("Setting current SWT charts components provider to: " + SWTChartsComponentsProvider.getCurrent() + ".");
-				break;
-			}
-		}
-	}
-	
-	
-	/**
-	 * Gets an SWT charts component provider according to the specified charts engine output format and provider supported input format. 
-	 * @param chartsEngine
-	 * @return
-	 */
-	public static SWTChartsComponentsProvider getComponentsProvider(ChartsEngine chartsEngine)	{
-		
-		SWTChartsComponentsProvider chartsComponentsProvider = null;
-		
-		for(int i = 0; i < SWTChartsComponentsProvider.chartsComponentsProviders.size(); i++) {
-			if(SWTChartsComponentsProvider.chartsComponentsProviders.get(i).getEditorSupportedInputFormats().contains(chartsEngine.getOutputFormat()))	{
-
-				chartsComponentsProvider = SWTChartsComponentsProvider.chartsComponentsProviders.get(i);
-				break;
-			}
-		}
-		
-		return chartsComponentsProvider;
-	}
-	
-	
-	/**
-	 * Gets an installed charts components provider according to its class type.
-	 * @param type
-	 * @return the installed charts components provider according to its class type if it exists otherwise null;
-	 */
-	public static SWTChartsComponentsProvider getComponentsProvider(Class type)	{
-		SWTChartsComponentsProvider provider = null;
-		for(int i = 0; i < SWTChartsComponentsProvider.chartsComponentsProviders.size(); i++) {
-			if(SWTChartsComponentsProvider.chartsComponentsProviders.get(i).getClass().equals(type))	{
-				provider = SWTChartsComponentsProvider.chartsComponentsProviders.get(i);
-				break;
-			}
-		}
-		return provider;
-	}
-
-	/**
-	 * Set the current charts engine.
-	 * @param chartsEngine the chartsEngine to set
-	 */
-	public void setChartsEngine(ChartsEngine chartsEngine) {
-		this.chartsEngine = chartsEngine;
-	}
-
-
-	/**
-	 * Gets the charts engine.
-	 * @return the chartsEngine
-	 */
-	public ChartsEngine getChartsEngine() {
-		return chartsEngine;
-	}
-
-
-	 /**
-	  * Creates the chart drawing area composite.
-	  * @param parent
-	  * @param style
-	  * @return the composite
-	  */
-	 public abstract ChartComposite createComposite(ChartEditor chartEditor, Composite parent);
-
-
-	/**
-	 * Returns the export formats supported by the implementation of the <code>EditorPart</code> for the view.
-	 * @return
-	 */
-	public abstract ArrayList<String> getEditorSupportedExportFileFormats();
-	
-	/**
-	 * Returns the input formats supported by the implementation of the <code>EditorPart</code> for viewing.
-	 * @return
-	 */
-	public List<String> getEditorSupportedInputFormats()	{
-		return this.supportedInputFormats;
-	}
-	
-
-	/**
-	 * Sets the input formats supported by the implementation of the <code>EditorPart</code> for viewing.
-	 * @param supportedInputFormats
-	 */
-	public void setEditorSupportedInputFormat(List<String> supportedInputFormats)	{
-		this.supportedInputFormats = supportedInputFormats;
-	}
-	
-	/**
-	 * Returns the export formats supported by the implementation of the <code>ChartsEngine</code> for the total chart.
-	 * @return
-	 */
-	public abstract ArrayList<String> getChartsEngineSupportedExportFileFormats();
-
-
-	/**
-	 * Creates a SWT group for the charts engine default preferences area in preference pages.
-	 * @return
-	 */
-	public static Group createChartsRenderingPreferencesGroup(Composite parent)	{
-
-		Group chartsGroup = new Group(parent, SWT.NONE);
-
-		chartsGroup.setText(SWTComponentsProviderMessages.ChartsEngineSharedPreferencePage_CHARTS_RENDERING_DEFAULT_PREFERENCES);
-
-		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, false);
-		gridData.horizontalSpan = 2;
-		gridData.verticalIndent = 10;
-		chartsGroup.setLayoutData(gridData);
-
-		return chartsGroup;
-	}
-	
-	
-	/**
-	 * 
-	 * @param parent
-	 * @return
-	 */
-	public static Composite createChartsRenderingPreferencesTabFolderComposite(Composite parent)	{
-		return createChartsRenderingPreferencesTabFolderComposite(parent, SWTComponentsProviderMessages.ChartsEngineSharedPreferencePage_CHARTS_RENDERING_DEFAULT_PREFERENCES);
-	}
-	
-	/**
-	 * Creates a tab folder with a tab item for rendering preferences.
-	 * @param parent
-	 * @return
-	 */
-	public static Composite createChartsRenderingPreferencesTabFolderComposite(Composite parent, String tabTitle)	{
-
-		
-		TabFolder tabFolder = new TabFolder(parent, SWT.TOP);
-		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, true);
-		gridData.horizontalSpan = 2;
-		tabFolder.setLayoutData(gridData);
-
-		TabItem tabItem = new TabItem(tabFolder, SWT.NULL);
-		tabItem.setText(tabTitle);
-		Composite composite = new Composite(tabFolder, SWT.NULL);
-		tabItem.setControl(composite);
-		
-
-		return composite;
-	}
-	
-	/**
-	 * 
-	 * @param page
-	 * @param composite
-	 */
-	public static void createChartsRenderingPreferencesFields(TXMPreferencePage page, Composite composite)	{
-		
-		Label separator = new Label(composite, SWT.HORIZONTAL | SWT.SEPARATOR);
-		GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
-		gridData.horizontalSpan = 2;
-		separator.setLayoutData(gridData);
-
-		String commandNodeQualifier = ((TXMPreferenceStore)page.getPreferenceStore()).getNodeQualifier(); 
-
-		// Show title
-		if(!TXMPreferences.isEmpty(commandNodeQualifier, ChartsEnginePreferences.SHOW_TITLE))	{
-			page.addField(new BooleanFieldEditor(ChartsEnginePreferences.SHOW_TITLE, SWTComponentsProviderMessages.SWTChartsComponentProvider_SHOW_TITLE, composite));
-		}
-		// Show legend
-		if(!TXMPreferences.isEmpty(commandNodeQualifier, ChartsEnginePreferences.SHOW_LEGEND))	{
-			page.addField(new BooleanFieldEditor(ChartsEnginePreferences.SHOW_LEGEND, SWTComponentsProviderMessages.SWTChartsComponentProvider_SHOW_LEGEND, composite));
-		}
-		// Show grid
-		if(!TXMPreferences.isEmpty(commandNodeQualifier, ChartsEnginePreferences.SHOW_GRID))	{
-			page.addField(new BooleanFieldEditor(ChartsEnginePreferences.SHOW_GRID, SWTComponentsProviderMessages.SWTChartsComponentProvider_SHOW_GRID, composite));
-		}
-
-		// Rendering colors mode selection
-		if(!TXMPreferences.isEmpty(commandNodeQualifier, ChartsEnginePreferences.RENDERING_COLORS_MODE))	{
-			String colorsModes[][] = new String[4][2];
-			colorsModes[0][0] = SWTComponentsProviderMessages.ChartsEnginePreferencePage_RenderingModeColors;
-			colorsModes[0][1] = "0"; //$NON-NLS-1$
-			colorsModes[1][0] = SWTComponentsProviderMessages.ChartsEnginePreferencePage_RenderingModeGrayscale;
-			colorsModes[1][1] = "1"; //$NON-NLS-1$
-			colorsModes[2][0] = SWTComponentsProviderMessages.ChartsEnginePreferencePage_RenderingModeBlackAndWhite;
-			colorsModes[2][1] = "2"; //$NON-NLS-1$
-			colorsModes[3][0] = SWTComponentsProviderMessages.ChartsEnginePreferencePage_RenderingModeMonochrome;
-			colorsModes[3][1] = "3"; //$NON-NLS-1$
-			ComboFieldEditor renderingModeComboField = new ComboFieldEditor(ChartsEnginePreferences.RENDERING_COLORS_MODE, SWTComponentsProviderMessages.ChartsEnginePreferencePage_RenderingColorsMode, colorsModes, composite);
-			page.addField(renderingModeComboField);
-		}
-
-		// Same lines stroke
-		if(!TXMPreferences.isEmpty(commandNodeQualifier, ChartsEnginePreferences.MULTIPLE_LINE_STROKES))	{
-			page.addField(new BooleanFieldEditor(ChartsEnginePreferences.MULTIPLE_LINE_STROKES, SWTComponentsProviderMessages.preferences_multipleLineStrokeStyles, composite));
-		}
-
-		
-	}
-	
-
-	
-	/**
-	 * Export the current view of chart editor in the specified file.
-	 * @param chartEditor
-	 * @param file
-	 * @param fileFormat
-	 * @return
-	 */
-	public abstract File exportView(ChartEditor chartEditor, File file, String fileFormat);
-
-	
-	/**
-	 * Opens the specified <code>ChartEditor</code> in the active page and registers the event listeners and context menus according to the type of the chart editor part.
-	 * The ID of the editor and the chart type are the editor input result data class name.
-	 * @param chartEditorInput
-	 * @return
-	 */
-	public ChartEditor openEditor(ChartEditorInput chartEditorInput)	{
-		return this.openEditor(chartEditorInput, chartEditorInput.getResult().getClass().getName());
-	}
-
-	
-	/**
-	 * Opens the <code>ChartEditor</code> specified by its id and ChartEditorInput in the active page and registers the event listeners and context menus according to the <code>EventCallBack</code> installed extensions. 
-	 * @param chartEditorInput
-	 * @param editorPartId
-	 * @param chartType
-	 * @return
-	 */
-	// FIXME: this method have some trouble when calling through a progress dialog
-	// FIXME: this method is not in use anymore since the editor opening is now down in TXMEditor so the code for ChartEngine downgrading is not 
-	// active anymore. Try to use again this code
-	public ChartEditor openEditor(ChartEditorInput chartEditorInput, String editorPartId)	{
-
-		ChartEditor openedChartEditorPart = null;
-
-		IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
-		IWorkbenchPage page = window.getActivePage();
-
-//		IWorkbenchWindow window = PlatformUI.getWorkbench().getWorkbenchWindows()[0];
-//		IWorkbenchPage page = window.getActivePage();
-		
-		boolean isAlreadyOpened = page.findEditors(chartEditorInput, editorPartId, IWorkbenchPage.MATCH_INPUT | IWorkbenchPage.MATCH_ID).length > 0;
-		
-		Log.info("SWTChartsComponentsProvider.openEditor(): opening editor with id " + editorPartId);
-		
-		// if the editor is already open or the charts engine can create the specified chart type
-		if(isAlreadyOpened || this.chartsEngine.canCreateChart(chartEditorInput.getResult()))	{
-			
-			//Log.info(this.name + " - Opening editor for result data type " + chartEditorInput.getResultData().getClass() + " and editor id " + editorPartId);
-
-			
-			try {
-				
-				openedChartEditorPart = (ChartEditor) page.openEditor(chartEditorInput, editorPartId, true, IWorkbenchPage.MATCH_INPUT | IWorkbenchPage.MATCH_ID);
-				openedChartEditorPart.setWasAlreadyOpened(isAlreadyOpened);
-				
-				
-				// directly returns if the editor was already opened
-				if(isAlreadyOpened)	{
-					return openedChartEditorPart;
-				}
-				
-				// compute the chart
-				//openedChartEditorPart.computeChart(false);
-
-				
-				// FIXME: directly close the editor if it contains no chart
-//				if(openedChartEditorPart.getChart() == null)	{
-//					page.closeEditor(openedChartEditorPart, false);
-//					return openedChartEditorPart;
-//				}
-				
-				// FIXME: tests with reuseEditor()
-				//openedChartEditorPart  = (ChartEditor) page.reuseEditor(editorPart, editorPart.getEditorInput());
-				
-				
-				//openedChartEditorPart.refreshCorporaView();
-				
-				openedChartEditorPart.forceFocus();
-				
-			}
-			catch(PartInitException e) {
-				e.printStackTrace();
-			}
-			
-		}
-		// get the first installed charts engine that can create chart and use the SWT provider matching it
-		else	{
-			Log.warning("Rendering failed with current charts engine, trying to rendering chart with other installed SWT components provider and other charts engine:");
-	
-			boolean canCreate = false;
-			for(int i = 0; i < ChartsEngine.getChartsEngines().size() && !canCreate; i++) {
-				if(ChartsEngine.getChartsEngines().get(i) != this.chartsEngine)	{
-					ChartsEngine chartsEngine = ChartsEngine.getChartsEngines().get(i);
-					canCreate = chartsEngine.canCreateChart(chartEditorInput.getResult());
-					// get a provider that can manage the charts engine
-					if(canCreate)	{
-						SWTChartsComponentsProvider provider = SWTChartsComponentsProvider.getComponentsProvider(chartsEngine);
-						if(provider != null)	{
-							provider.setChartsEngine(chartsEngine);
-							chartEditorInput.setSWTChartsComponentsProvider(provider);
-							Log.warning(provider.toString());
-							return provider.openEditor(chartEditorInput, editorPartId);
-						}
-					}
-				}
-			}
-		}
-		
-		return openedChartEditorPart;
-	}
-	
-	/**
-	 * 
-	 * @param titleImage
-	 * @param editorInputName
-	 * @param result
-	 * @param chartType
-	 * @param params
-	 * @return
-	 */
-	public ChartEditor openEditor(ChartResult result)	{
-		return this.openEditor(this.createChartEditorInput(result), result.getClass().getName());
-	}
-	
-	
-	/**
-	 * Initializes the default context menus.
-	 * @param composite
-	 */
-	public static void initDefaultContextMenus(ChartComposite composite)	{
-		if(composite != null)	{
-			composite.initItemAreaContextMenu();
-			composite.initEmptyAreaContextMenu();
-			composite.setCurrentContextMenu(EventCallBack.AREA_EMPTY);
-		}
-	}
-
-	
-	/**
-	 * Gets the current active chart editor managing the multi pages editor.
-	 * @param event
-	 * @return
-	 */
-	public static ChartEditor getActiveChartEditor(ExecutionEvent event)	{
-		ChartEditor chartEditor = null;
-
-		Event eevent = (Event)event.getTrigger();
-		Widget widget = eevent.widget;
-		// Toolbars
-		if(event != null && widget instanceof ToolItem)	{
-			ToolItem to = (ToolItem) widget;
-			ToolBar parent = to.getParent();
-			if(to.getParent() instanceof ChartEditorToolBar)	{
-				chartEditor = ((ChartEditorToolBar)((ToolItem)((Event)event.getTrigger()).widget).getParent()).getEditorPart();	
-			}
-			if(to.getParent() instanceof AdvancedChartEditorToolBar)	{
-				chartEditor = ((AdvancedChartEditorToolBar)((ToolItem)((Event)event.getTrigger()).widget).getParent()).getEditorPart();
-			}
-		}
-		// Context menu, multi pages editor
-		else if(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart() instanceof SplitedGenericMultiPageEditor)	{
-			// Main editor
-			if(((SplitedGenericMultiPageEditor) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart()).getMainEditorPart() instanceof ChartEditor
-					&& ((ChartEditor)((SplitedGenericMultiPageEditor) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart()).getMainEditorPart()).hasFocus())	{
-				chartEditor = (ChartEditor)((SplitedGenericMultiPageEditor) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart()).getMainEditorPart();
-			}
-			else if(((MultiPageEditorPart) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActiveEditor()).getSelectedPage() instanceof ChartEditor
-					&& ((ChartEditor)((MultiPageEditorPart) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActiveEditor()).getSelectedPage()).hasFocus() )	{
-				chartEditor = (ChartEditor)((MultiPageEditorPart) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActiveEditor()).getSelectedPage();
-			}
-		}
-		// Context menu, Normal editor
-		else if(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart() instanceof ChartEditor)	{
-			chartEditor = (ChartEditor) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart();	
-		}
-		return chartEditor;
-	}
-	
-	/**
-	 * Initializes AWT default events to delegate AWT events to SWT.
-	 * @param chartEditor
-	 * @param swingComponent
-	 */
-	public static void initializeAWTDelegationListeners(final ChartEditor chartEditor, final JComponent swingComponent)	{
-
-		// AWT to  SWT
-		swingComponent.addMouseMotionListener(new MouseMotionListener() {
-
-			@Override
-			public void mouseMoved(final MouseEvent e) {
-				chartEditor.getComposite().getDisplay().asyncExec(new Runnable () {
-					public void run() {
-						if(!chartEditor.getComposite().isDisposed())	{
-							chartEditor.getComposite().notifyListeners(SWT.MouseMove, SWTChartsComponentsProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.MouseMove));
-						}
-					}
-				});
-			}
-
-			@Override
-			public void mouseDragged(MouseEvent e) {
-				// TODO Auto-generated method stub
-
-			}
-		});
-
-		swingComponent.addMouseListener(new MouseListener() {
-
-			@Override
-			public void mouseReleased(final MouseEvent e) {
-				chartEditor.getComposite().getDisplay().asyncExec(new Runnable () {
-					public void run() {
-						
-						// FIXME: context menu
-						if(e.isPopupTrigger())	{
-
-							//System.err.println("SWTChartsComponentsProvider.initializeAWTDelegationListeners(...).new MouseListener() {...}.mouseReleased(...).new Runnable() {...}.run(): AWT popup trigger detected");
-							
-
-							
-							// update the mouse over item selection according to the mouse event
-							chartEditor.getComposite().getChartComponent().updateMouseOverItem(e);
-							
-							// manually pop up the menu
-							if(chartEditor.getComposite().getMenu() != null)	{
-								chartEditor.getComposite().getMenu().setLocation(new Point(e.getXOnScreen(), e.getYOnScreen()));
-								chartEditor.getComposite().getMenu().setVisible(true);
-							}
-
-							// FIXME: the SWT.MenuDetect event delegation doesn't work, it would be better than manually pop up the menu (but other problem is the dynamic menu on chart entity item)
-							//chartEditor.getComposite().notifyListeners(SWT.MenuDetect, SWTChartsComponentProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.MenuDetect));
-							// FIXME: try to delegate the Menu detect event, DOES NOT SEEM TO WORK
-							//chartEditor.getComposite().notifyListeners(SWT.MenuDetect, SWTChartsComponentsProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.MenuDetect));
-							//chartEditor.getComposite().notifyListeners(SWT.Show, SWTChartsComponentsProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.Show));
-							
-						}
-						chartEditor.getComposite().notifyListeners(SWT.MouseUp, SWTChartsComponentsProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.MouseUp));
-						//chartEditor.activate();
-					}
-				});
-			}
-
-			@Override
-			public void mousePressed(final MouseEvent e) {
-
-				// SWT thread
-				chartEditor.getComposite().getDisplay().asyncExec(new Runnable() {
-					@Override
-					public void run() {
-
-						chartEditor.getComposite().notifyListeners(SWT.MouseDown, SWTChartsComponentsProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.MouseDown));
-						
-						// FIXME: Debug
-//						System.out.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new MouseListener() {...}.mousePressed(...).new Runnable() {...}.run()");
-						// Activate the editor part on AWT mouse pressed event
-						chartEditor.activate();
-//						chartEditor.forceFocus();
-					}
-				});
-
-			}
-
-			@Override
-			public void mouseExited(java.awt.event.MouseEvent e) {
-				// TODO Auto-generated method stub
-
-			}
-
-			@Override
-			public void mouseEntered(java.awt.event.MouseEvent e) {
-
-				// TODO: DEbug
-				//System.err.println("SWTChartsComponentProvider.initializeSwingDelegationListeners(...) AWT mouse entered");
-
-				// Force the focus in the component on mouse enter
-				/*if(!swingComponent.isFocusOwner())	{
-
-					// SWT thread
-					if(!chartEditor.getComposite().isDisposed())	{
-						chartEditor.getComposite().getDisplay().asyncExec(new Runnable() {
-							public void run() {
-	
-	
-								// FIXME: this code works on Windows and Linux but activate() the chart editor when mouse enters
-								//chartEditor.activate();
-	
-								EventQueue.invokeLater(new Runnable () {
-									public void run () {
-								
-										// TODO: this code forces to give the focus to the embedded AWT Frame under Windows (#1127 related)
-										// For unknown reason Frame.requestFocusInWindow() doesn't work and always return false here
-										// This code is not sufficient for Linux
-										System.out.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...) trying to give focus to root embedded frame");
-										try {
-											Frame frame = (Frame) swingComponent.getFocusCycleRootAncestor();
-											//frame.synthesizeWindowActivation(true);
-											Class clazz = frame.getClass();
-											Method method = clazz.getMethod("synthesizeWindowActivation", new Class[]{boolean.class});
-											if(method != null)	{
-												method.invoke(frame, new Object[]{new Boolean(true)});
-												System.out.println("SWTChartsComponentProvider.initializeSwingDelegationListeners(...).new MouseListener() {...}.mouseEntered(...).new Runnable() {...}.run(): " + frame);
-			
-											}
-			
-											//frame.requestFocusInWindow();
-			
-			                            }
-										catch (Throwable e) {
-											Log.printStackTrace(e);
-										}
-									}
-								});
-								
-								
-								//System.out.println("SWTChartsComponentProvider.initializeSwingDelegationListeners) AWT give focus to frame = " + ((JFCComposite)chartEditor.getComposite()).frame.requestFocusInWindow());
-	
-	
-	//							chartEditor.setFocus();
-	//							System.out.println("SWTChartsComponentProvider.initializeSwingDelegationListeners() SWT got focus = " + chartEditor.getComposite().setFocus());
-	
-	//							EventQueue.invokeLater(new Runnable () {
-	//								public void run () {
-										//swingComponent.requestFocusInWindow();
-	
-	//									System.out.println("SWTChartsComponentProvider.initializeSwingDelegationListeners() AWT got focus = " + swingComponent.requestFocusInWindow());
-	//								}
-	//							});
-	
-	
-	
-							}
-						});
-					}
-				}*/
-			}
-
-			@Override
-			public void mouseClicked(java.awt.event.MouseEvent e) {
-				// TODO Auto-generated method stub
-
-			}
-		});
-
-
-
-
-		// SWT
-
-		// SWT Tooltips tests
-
-
-//		toolTip = new DefaultToolTip(this, org.eclipse.jface.window.ToolTip.RECREATE, true);
-//		toolTip.setPopupDelay(500);
-
-
-
-		// FIXME: test HTML
-//		toolTip = new ___CustomHTMLToolTip(this, org.eclipse.jface.window.ToolTip.NO_RECREATE, true);
-//		toolTip.setShift(new Point(10, 50));
-
-
-
-
-		// Define AWT events, needed to properly give the focus to the Swing component and manage the mouse events
-		Listener listener;
-
-		//FIXME: useless ?
-		// Run event queue dispose event
-//		listener = new Listener () {
-//			 public void handleEvent (Event e) {
-//			   switch (e.type) {
-//					case SWT.Dispose:
-//						chartPanel.getParent().setVisible(false);
-//						EventQueue.invokeLater(new Runnable () {
-//						public void run() {
-//							((Frame) chartPanel.getParent().getParent()).dispose();
-//						}
-//					});
-//				   break;
-//			   }
-//		   }
-//		};
-//		this.addListener(SWT.Dispose, listener);
-
-
-		// Handle the AWT/Swing events delegation
-		listener = new Listener () {
-			public void handleEvent (Event e) {
-				switch (e.type) {
-					case SWT.FocusIn:
-						// FIXME: DEbug
-//						System.out.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT composite gained focus");
-						chartEditor.getComposite().requestFocusInComposite();
-						break;
-					case SWT.MouseMove:
-						//System.err.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT mouse move: " + e.x + " : " + e.y);
-
-//						// FIXME: SWT tool tips test
-//						ToolTip tip = new ToolTip(getShell(), SWT.BALLOON | SWT.ID_HIDE);
-//						tip.setMessage("test tool tip SWT");
-//						tip.setLocation(getDisplay().map(self, null, new Point(e.x, e.y)));
-//						tip.setVisible(true);
-
-//						// FIXME: JFace tool tips test
-//						//DefaultToolTip tip2 = new DefaultToolTip( self, SWT.NONE, true );
-//						//toolTip.setShift(new Point(e.x, e.y));
-//						//toolTip.setText("<html><body><p>rtrt <font style=\"color: red\">yuyuyu</font></p></body></html>");
-//						toolTip.setText(e.text);
-//						if(e.text != null)	{
-//							toolTip.show(new Point(e.x, e.y));
-//						}
-//						else	{
-//							toolTip.hide();
-//						}
-
-						// FIXME: JFace tool tips test 2
-//						toolTip.setText(e.text);
-//						if(e.text != null)	{
-//							toolTip.show(new Point(e.x, e.y));
-//						}
-//						else	{
-//							toolTip.hide();
-//						}
-
-
-
-						break;
-					case SWT.MouseDown:
-						// FIXME: to test in Linux and Mac, it should fix the focus bugs in CA chart between table focus and chart composite/panel focus + Linux singular values bar plot focus bug
-						//System.err.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT mouse down : set focus in composite and request focus in chart panel");
-						chartEditor.getComposite().setFocus();
-						chartEditor.getComposite().requestFocusInComposite();
-						break;
-					case SWT.MouseUp:
-						//System.err.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT mouse up");
-						break;
-
-					case SWT.MouseEnter:
-						//System.err.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT mouse enter");
-						break;
-
-
-					case SWT.Activate:
-						//System.err.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT activate");
-						chartEditor.getComposite().requestFocusInComposite();
-						break;
-				}
-		   }
-		};
-		chartEditor.getComposite().addListener(SWT.FocusIn, listener);
-		chartEditor.getComposite().addListener(SWT.MouseDown, listener); // needed to manage the focus delegation between SWT and AWT/Swing
-
-//		chartEditor.getComposite().addListener(SWT.MouseEnter, listener); // TODO : test AWT delegation
-	//	chartEditor.getComposite().addListener(SWT.Activate, listener); // TODO : test AWT delegation
-
-
-		// FIXME: For Swing focus debug
-		swingComponent.addFocusListener(new FocusListener() {
-			
-			@Override
-			public void focusLost(FocusEvent e) {
-				// TODO Auto-generated method stub
-				swingComponent.setBorder(javax.swing.BorderFactory.createEmptyBorder());
-				Display.getDefault().asyncExec(new Runnable() {
-					
-					@Override
-					public void run() {
-						// TODO Auto-generated method stub
-						chartEditor.deactivateContext();						
-					}
-				});
-			}
-			
-			@Override
-			public void focusGained(FocusEvent e) {
-				// TODO Auto-generated method stub
-				swingComponent.setBorder(new LineBorder(Color.red, 1));
-				
-				Display.getDefault().asyncExec(new Runnable() {
-					
-					@Override
-					public void run() {
-						// TODO Auto-generated method stub
-						chartEditor.activateContext();						
-					}
-				});
-			}
-		});
-		
-
-		// FIXME: SWT tool tips test rather than using Swing
-		//chartEditor.getComposite().addListener(SWT.MouseMove, listener);
-	//	chartEditor.getComposite().addListener(SWT.MouseUp, listener);
-
-
-
-	}
-
-	/**
-	 * Converts an AWT event to SWT event. Also stores the Swing tool tip source text of the specified Swing component in the SWT event to give it to the SWT composite listener in <code>ChartComposite</code>.
-	 * @param swtComposite
-	 * @param swingComponent
-	 * @param e
-	 * @param eventType
-	 * @return
-	 */
-	// TODO : this method is incomplete
-	public static org.eclipse.swt.widgets.Event swingEventToSWT(Composite swtComposite, JComponent swingComponent, MouseEvent e, int eventType)	{
-
-		Event event = new Event();
-		event.button = e.getButton();
-		if(!swtComposite.isDisposed())	{
-			event.display = swtComposite.getDisplay();
-		}
-		event.widget = swtComposite;
-		event.type = eventType;
-
-		try {
-			// Store the Swing tool tip source text in the SWT event to give it to the SWT composite listener in ChartComposite
-			// NOTE: this method call sometimes throws a java.lang.IndexOutOfBoundsException
-			event.text = swingComponent.getToolTipText(e);
-		}
-		catch(Exception e1) {
-			//e1.printStackTrace();
-		}
-		event.x = e.getX();
-		event.y = e.getY();
-		return event;
-	}
-
-	
-
-	@Override
-	public String toString() {
-		String str = this.name + " ("; //$NON-NLS-1$
-		str += "supported input formats: " + this.supportedInputFormats.toString().replaceAll("\\[|\\]", ""); //$NON-NLS-1$ //$NON-NLS-2$
-		str += ", Charts Engine: " + this.chartsEngine + ")"; //$NON-NLS-1$ //$NON-NLS-2$
-		return str;
-	}
-
-
-	/**
-	 * @param name the name to set
-	 */
-	public void setName(String name) {
-		this.name = name;
-	}
-
-
-
-}
-
+package org.txm.chartsengine.rcp;
+
+
+import java.awt.Color;
+import java.awt.event.FocusEvent;
+import java.awt.event.FocusListener;
+import java.awt.event.MouseEvent;
+import java.awt.event.MouseListener;
+import java.awt.event.MouseMotionListener;
+import java.io.File;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+import java.util.Properties;
+
+import javax.swing.JComponent;
+import javax.swing.border.LineBorder;
+
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.runtime.CoreException;
+import org.eclipse.core.runtime.IConfigurationElement;
+import org.eclipse.core.runtime.Platform;
+import org.eclipse.jface.preference.BooleanFieldEditor;
+import org.eclipse.jface.preference.ComboFieldEditor;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.graphics.Point;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Display;
+import org.eclipse.swt.widgets.Event;
+import org.eclipse.swt.widgets.Group;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Listener;
+import org.eclipse.swt.widgets.TabFolder;
+import org.eclipse.swt.widgets.TabItem;
+import org.eclipse.swt.widgets.ToolBar;
+import org.eclipse.swt.widgets.ToolItem;
+import org.eclipse.swt.widgets.Widget;
+import org.eclipse.ui.IWorkbenchPage;
+import org.eclipse.ui.IWorkbenchWindow;
+import org.eclipse.ui.PartInitException;
+import org.eclipse.ui.PlatformUI;
+import org.eclipse.ui.contexts.IContextService;
+import org.eclipse.ui.part.MultiPageEditorPart;
+import org.txm.chartsengine.core.ChartsEngine;
+import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
+import org.txm.chartsengine.core.results.ChartResult;
+import org.txm.chartsengine.rcp.editors.ChartEditor;
+import org.txm.chartsengine.rcp.editors.ChartEditorInput;
+import org.txm.chartsengine.rcp.events.EventCallBack;
+import org.txm.chartsengine.rcp.messages.SWTComponentsProviderMessages;
+import org.txm.chartsengine.rcp.preferences.___KeyboardBindingProperties;
+import org.txm.chartsengine.rcp.preferences.___MouseBindingProperties;
+import org.txm.chartsengine.rcp.swt.AdvancedChartEditorToolBar;
+import org.txm.chartsengine.rcp.swt.ChartComposite;
+import org.txm.chartsengine.rcp.swt.ChartEditorToolBar;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.rcp.editors.SplitedGenericMultiPageEditor;
+import org.txm.rcp.preferences.TXMPreferencePage;
+import org.txm.rcp.preferences.TXMPreferenceStore;
+import org.txm.utils.logger.Log;
+
+/**
+ * A class providing EditorPart and EditorInput according to the current charts engine.
+ * @author sjacquot
+ * 
+ */
+public abstract class SWTChartsComponentsProvider {
+
+	
+	
+	
+	
+	// FIXME: should be done in an activator?
+	static	{
+		// Initializes the SWT Charts Components provider according to the current charts engine and its output format
+		SWTChartsComponentsProvider.createSWTChartsComponentsProviders();
+		SWTChartsComponentsProvider.setCurrrentComponentsProvider(ChartsEngine.getCurrent());
+	}
+	
+	
+	
+	
+	
+	/**
+	 * The charts engine.
+	 */
+	protected ChartsEngine chartsEngine;
+
+
+	/**
+	 * The name of the provider.
+	 */
+	protected String name;
+	
+	/**
+	 * The supported editor input formats.
+	 */
+	protected List<String> supportedInputFormats;
+	
+	
+	/**
+	 * Mouse control properties which will be shared by all implementations and chart editors.
+	 */
+	protected Properties mouseBindingProperties;
+
+
+	/**
+	 * Keyboard control properties which will be shared by all implementations and chart editors.
+	 */
+	protected Properties keyboardBindingProperties;
+
+	
+	/**
+	 * Installed SWT charts components providers.
+	 */
+	protected static ArrayList<SWTChartsComponentsProvider> chartsComponentsProviders;
+	
+	/**
+	 * Current SWT charts components provider index in the providers list.
+	 */
+	protected static int currentChartsComponentsProviderIndex;
+	
+	
+	
+	public SWTChartsComponentsProvider(ChartsEngine chartsEngine, Properties mouseBindingProperties, Properties keyboardBindingProperties) {
+		this.chartsEngine = chartsEngine;
+
+		this.mouseBindingProperties = mouseBindingProperties;
+		this.keyboardBindingProperties = keyboardBindingProperties;
+
+		// FIXME : see if we need to define the L&F as system for AWT/Swing components
+		// If yes, we need to find a way to manage the GTK L&F/Linux bug, see ticket #761
+        // System Look and feel
+//        try {
+//			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
+//		}
+//		catch(ClassNotFoundException e) {
+//			// TODO Auto-generated catch block
+//			e.printStackTrace();
+//		}
+//		catch(InstantiationException e) {
+//			// TODO Auto-generated catch block
+//			e.printStackTrace();
+//		}
+//		catch(IllegalAccessException e) {
+//			// TODO Auto-generated catch block
+//			e.printStackTrace();
+//		}
+//		catch(UnsupportedLookAndFeelException e) {
+//			// TODO Auto-generated catch block
+//			e.printStackTrace();
+//		}
+	}
+
+	/**
+	 * 
+	 * @param chartsEngine
+	 */
+	public SWTChartsComponentsProvider(ChartsEngine chartsEngine) {
+		this(chartsEngine, new ___MouseBindingProperties(), new ___KeyboardBindingProperties());
+	}
+
+	
+	/**
+	 * 
+	 */
+	public SWTChartsComponentsProvider() {
+		this(null);
+	}
+
+	
+	/**
+	 * Creates a <code>ChartEditorInput</code> for the specified chart result.
+	 * @param result
+	 * @return a <code>ChartEditorInput</code>
+	 */
+	public ChartEditorInput createChartEditorInput(ChartResult result) {
+		return new ChartEditorInput(this, result);
+	}
+	
+	/**
+	 * Creates a new chart container for the specified <code>ChartResult</code> save it in the specified <code>ChartEditorInput</code>.
+	 * 
+	 * @param chartsEngine
+	 * @param chartEditorInput
+	 * @param result
+	 * @param preferencesNode
+	 * @param chartType
+	 * @return
+	 */
+	protected abstract boolean createChartContainer(ChartsEngine chartsEngine, ChartEditorInput chartEditorInput);
+	
+	/**
+	 * Creates a new chart container for the specified <code>ChartResult</code> save it in the specified <code>ChartEditorInput</code>.
+	 * 
+	 * @param chartEditorInput
+	 * @param result
+	 * @param preferencesNode
+	 * @param chartType
+	 * @return
+	 */
+	public boolean createChartContainer(ChartEditorInput chartEditorInput)	{
+		Log.finest(this.getClass().getName() + ": creating a chart container...");
+		return this.createChartContainer(this.getChartsEngine(), chartEditorInput);
+	}
+	
+	
+	/**
+	 * Creates and stores SWT charts components providers from installed extension contributions and define the current one according to the specified charts engine output format and provider supported input format.
+	 */
+	public static void createSWTChartsComponentsProviders()	{
+		
+		
+		SWTChartsComponentsProvider.chartsComponentsProviders = new ArrayList<SWTChartsComponentsProvider>();
+		
+		String extensionPointId = "org.txm.rcp.swtchartscomponentsprovider"; //$NON-NLS-1$
+		IConfigurationElement[] contributions = Platform.getExtensionRegistry().getConfigurationElementsFor(extensionPointId);
+		
+		for(int i = 0; i < contributions.length; i++) {
+			
+			// FIXME: to manage more than one input format, Store them in the class rather than in the extension schema?
+			String formatsStr = contributions[i].getAttribute("inputFormat").replace(" ", "").trim();
+			String[] formats = formatsStr.split(",");
+			
+			try {
+				SWTChartsComponentsProvider swtChartsComponentsProvider = (SWTChartsComponentsProvider)contributions[i].createExecutableExtension("class");  //$NON-NLS-1$
+				swtChartsComponentsProvider.setName(contributions[i].getAttribute("name")); //$NON-NLS-1$
+				swtChartsComponentsProvider.setEditorSupportedInputFormat(Arrays.asList(formats));
+				
+				// Add the first charts engine that supports the input format
+				ChartsEngine chartsEngine = null;
+				for(int j = 0; j < formats.length; j++) {
+					chartsEngine = ChartsEngine.getChartsEngine(formats[j]);
+					if(chartsEngine != null)	{
+						break;
+					}
+				}
+				swtChartsComponentsProvider.setChartsEngine(chartsEngine);					
+				
+				SWTChartsComponentsProvider.chartsComponentsProviders.add(swtChartsComponentsProvider);
+				Log.warning("Starting SWT charts components provider: " + swtChartsComponentsProvider + ".");
+				
+				
+			}
+			catch(CoreException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+	}
+	
+	
+	/**
+	 * Gets the current charts component provider.
+	 * @return the current charts engine
+	 */
+	public static SWTChartsComponentsProvider getCurrent()	{
+		return SWTChartsComponentsProvider.chartsComponentsProviders.get(SWTChartsComponentsProvider.currentChartsComponentsProviderIndex);
+	}
+	
+	/**
+	 * Sets the current charts component provider according to the specified charts engine output format and provider supported input format. 
+	 * @param name the name of the charts engine to set as current
+	 */
+	public static void setCurrrentComponentsProvider(ChartsEngine chartsEngine)	{
+		for(int i = 0; i < SWTChartsComponentsProvider.chartsComponentsProviders.size(); i++) {
+			if(SWTChartsComponentsProvider.chartsComponentsProviders.get(i).getEditorSupportedInputFormats().contains(chartsEngine.getOutputFormat()))	{
+				// Set new charts engine
+				SWTChartsComponentsProvider.chartsComponentsProviders.get(i).setChartsEngine(chartsEngine);
+				
+				SWTChartsComponentsProvider.currentChartsComponentsProviderIndex = i;
+				Log.finest("Setting current SWT charts components provider to: " + SWTChartsComponentsProvider.getCurrent() + ".");
+				break;
+			}
+		}
+	}
+	
+	
+	/**
+	 * Gets an SWT charts component provider according to the specified charts engine output format and provider supported input format. 
+	 * @param chartsEngine
+	 * @return
+	 */
+	public static SWTChartsComponentsProvider getComponentsProvider(ChartsEngine chartsEngine)	{
+		
+		SWTChartsComponentsProvider chartsComponentsProvider = null;
+		
+		for(int i = 0; i < SWTChartsComponentsProvider.chartsComponentsProviders.size(); i++) {
+			if(SWTChartsComponentsProvider.chartsComponentsProviders.get(i).getEditorSupportedInputFormats().contains(chartsEngine.getOutputFormat()))	{
+
+				chartsComponentsProvider = SWTChartsComponentsProvider.chartsComponentsProviders.get(i);
+				break;
+			}
+		}
+		
+		return chartsComponentsProvider;
+	}
+	
+	
+	/**
+	 * Gets an installed charts components provider according to its class type.
+	 * @param type
+	 * @return the installed charts components provider according to its class type if it exists otherwise null;
+	 */
+	public static SWTChartsComponentsProvider getComponentsProvider(Class type)	{
+		SWTChartsComponentsProvider provider = null;
+		for(int i = 0; i < SWTChartsComponentsProvider.chartsComponentsProviders.size(); i++) {
+			if(SWTChartsComponentsProvider.chartsComponentsProviders.get(i).getClass().equals(type))	{
+				provider = SWTChartsComponentsProvider.chartsComponentsProviders.get(i);
+				break;
+			}
+		}
+		return provider;
+	}
+
+	/**
+	 * Set the current charts engine.
+	 * @param chartsEngine the chartsEngine to set
+	 */
+	public void setChartsEngine(ChartsEngine chartsEngine) {
+		this.chartsEngine = chartsEngine;
+	}
+
+
+	/**
+	 * Gets the charts engine.
+	 * @return the chartsEngine
+	 */
+	public ChartsEngine getChartsEngine() {
+		return chartsEngine;
+	}
+
+
+	 /**
+	  * Creates the chart drawing area composite.
+	  * @param parent
+	  * @param style
+	  * @return the composite
+	  */
+	 public abstract ChartComposite createComposite(ChartEditor chartEditor, Composite parent);
+
+
+	/**
+	 * Returns the export formats supported by the implementation of the <code>EditorPart</code> for the view.
+	 * @return
+	 */
+	public abstract ArrayList<String> getEditorSupportedExportFileFormats();
+	
+	/**
+	 * Returns the input formats supported by the implementation of the <code>EditorPart</code> for viewing.
+	 * @return
+	 */
+	public List<String> getEditorSupportedInputFormats()	{
+		return this.supportedInputFormats;
+	}
+	
+
+	/**
+	 * Sets the input formats supported by the implementation of the <code>EditorPart</code> for viewing.
+	 * @param supportedInputFormats
+	 */
+	public void setEditorSupportedInputFormat(List<String> supportedInputFormats)	{
+		this.supportedInputFormats = supportedInputFormats;
+	}
+	
+	/**
+	 * Returns the export formats supported by the implementation of the <code>ChartsEngine</code> for the total chart.
+	 * @return
+	 */
+	public abstract ArrayList<String> getChartsEngineSupportedExportFileFormats();
+
+
+	/**
+	 * Creates a SWT group for the charts engine default preferences area in preference pages.
+	 * @return
+	 */
+	public static Group createChartsRenderingPreferencesGroup(Composite parent)	{
+
+		Group chartsGroup = new Group(parent, SWT.NONE);
+
+		chartsGroup.setText(SWTComponentsProviderMessages.chartsRendering);
+
+		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, false);
+		gridData.horizontalSpan = 2;
+		gridData.verticalIndent = 10;
+		chartsGroup.setLayoutData(gridData);
+
+		return chartsGroup;
+	}
+	
+	
+	/**
+	 * 
+	 * @param parent
+	 * @return
+	 */
+	public static Composite createChartsRenderingPreferencesTabFolderComposite(Composite parent)	{
+		return createChartsRenderingPreferencesTabFolderComposite(parent, SWTComponentsProviderMessages.chartsRendering);
+	}
+	
+	/**
+	 * Creates a tab folder with a tab item for rendering preferences.
+	 * @param parent
+	 * @return
+	 */
+	public static Composite createChartsRenderingPreferencesTabFolderComposite(Composite parent, String tabTitle)	{
+
+		
+		TabFolder tabFolder = new TabFolder(parent, SWT.TOP);
+		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, true);
+		gridData.horizontalSpan = 2;
+		tabFolder.setLayoutData(gridData);
+
+		TabItem tabItem = new TabItem(tabFolder, SWT.NULL);
+		tabItem.setText(tabTitle);
+		Composite composite = new Composite(tabFolder, SWT.NULL);
+		tabItem.setControl(composite);
+		
+
+		return composite;
+	}
+	
+	/**
+	 * 
+	 * @param page
+	 * @param composite
+	 */
+	public static void createChartsRenderingPreferencesFields(TXMPreferencePage page, Composite composite)	{
+		
+		Label separator = new Label(composite, SWT.HORIZONTAL | SWT.SEPARATOR);
+		GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
+		gridData.horizontalSpan = 2;
+		separator.setLayoutData(gridData);
+
+		String commandNodeQualifier = ((TXMPreferenceStore)page.getPreferenceStore()).getNodeQualifier(); 
+
+		// Show title
+		if(!TXMPreferences.isEmpty(commandNodeQualifier, ChartsEnginePreferences.SHOW_TITLE))	{
+			page.addField(new BooleanFieldEditor(ChartsEnginePreferences.SHOW_TITLE, SWTComponentsProviderMessages.showTitle, composite));
+		}
+		// Show legend
+		if(!TXMPreferences.isEmpty(commandNodeQualifier, ChartsEnginePreferences.SHOW_LEGEND))	{
+			page.addField(new BooleanFieldEditor(ChartsEnginePreferences.SHOW_LEGEND, SWTComponentsProviderMessages.showLegend, composite));
+		}
+		// Show grid
+		if(!TXMPreferences.isEmpty(commandNodeQualifier, ChartsEnginePreferences.SHOW_GRID))	{
+			page.addField(new BooleanFieldEditor(ChartsEnginePreferences.SHOW_GRID, SWTComponentsProviderMessages.showGrid, composite));
+		}
+
+		// Rendering colors mode selection
+		if(!TXMPreferences.isEmpty(commandNodeQualifier, ChartsEnginePreferences.RENDERING_COLORS_MODE))	{
+			String colorsModes[][] = new String[4][2];
+			colorsModes[0][0] = SWTComponentsProviderMessages.colors;
+			colorsModes[0][1] = "0"; //$NON-NLS-1$
+			colorsModes[1][0] = SWTComponentsProviderMessages.grayscale;
+			colorsModes[1][1] = "1"; //$NON-NLS-1$
+			colorsModes[2][0] = SWTComponentsProviderMessages.blackAndWhite;
+			colorsModes[2][1] = "2"; //$NON-NLS-1$
+			colorsModes[3][0] = SWTComponentsProviderMessages.monochrome;
+			colorsModes[3][1] = "3"; //$NON-NLS-1$
+			ComboFieldEditor renderingModeComboField = new ComboFieldEditor(ChartsEnginePreferences.RENDERING_COLORS_MODE, SWTComponentsProviderMessages.renderingColorsMode, colorsModes, composite);
+			page.addField(renderingModeComboField);
+		}
+
+		// Same lines stroke
+		if(!TXMPreferences.isEmpty(commandNodeQualifier, ChartsEnginePreferences.MULTIPLE_LINE_STROKES))	{
+			page.addField(new BooleanFieldEditor(ChartsEnginePreferences.MULTIPLE_LINE_STROKES, SWTComponentsProviderMessages.multipleLineStrokeStyles, composite));
+		}
+
+		
+	}
+	
+
+	
+	/**
+	 * Export the current view of chart editor in the specified file.
+	 * @param chartEditor
+	 * @param file
+	 * @param fileFormat
+	 * @return
+	 */
+	public abstract File exportView(ChartEditor chartEditor, File file, String fileFormat);
+
+	
+	/**
+	 * Opens the specified <code>ChartEditor</code> in the active page and registers the event listeners and context menus according to the type of the chart editor part.
+	 * The ID of the editor and the chart type are the editor input result data class name.
+	 * @param chartEditorInput
+	 * @return
+	 */
+	public ChartEditor openEditor(ChartEditorInput chartEditorInput)	{
+		return this.openEditor(chartEditorInput, chartEditorInput.getResult().getClass().getName());
+	}
+
+	
+	/**
+	 * Opens the <code>ChartEditor</code> specified by its id and ChartEditorInput in the active page and registers the event listeners and context menus according to the <code>EventCallBack</code> installed extensions. 
+	 * @param chartEditorInput
+	 * @param editorPartId
+	 * @param chartType
+	 * @return
+	 */
+	// FIXME: this method have some trouble when calling through a progress dialog
+	// FIXME: this method is not in use anymore since the editor opening is now down in TXMEditor so the code for ChartEngine downgrading is not 
+	// active anymore. Try to use again this code
+	public ChartEditor openEditor(ChartEditorInput chartEditorInput, String editorPartId)	{
+
+		ChartEditor openedChartEditorPart = null;
+
+		IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
+		IWorkbenchPage page = window.getActivePage();
+
+//		IWorkbenchWindow window = PlatformUI.getWorkbench().getWorkbenchWindows()[0];
+//		IWorkbenchPage page = window.getActivePage();
+		
+		boolean isAlreadyOpened = page.findEditors(chartEditorInput, editorPartId, IWorkbenchPage.MATCH_INPUT | IWorkbenchPage.MATCH_ID).length > 0;
+		
+		Log.info("SWTChartsComponentsProvider.openEditor(): opening editor with id " + editorPartId);
+		
+		// if the editor is already open or the charts engine can create the specified chart type
+		if(isAlreadyOpened || this.chartsEngine.canCreateChart(chartEditorInput.getResult()))	{
+			
+			//Log.info(this.name + " - Opening editor for result data type " + chartEditorInput.getResultData().getClass() + " and editor id " + editorPartId);
+
+			
+			try {
+				
+				openedChartEditorPart = (ChartEditor) page.openEditor(chartEditorInput, editorPartId, true, IWorkbenchPage.MATCH_INPUT | IWorkbenchPage.MATCH_ID);
+				openedChartEditorPart.setWasAlreadyOpened(isAlreadyOpened);
+				
+				
+				// directly returns if the editor was already opened
+				if(isAlreadyOpened)	{
+					return openedChartEditorPart;
+				}
+				
+				// compute the chart
+				//openedChartEditorPart.computeChart(false);
+
+				
+				// FIXME: directly close the editor if it contains no chart
+//				if(openedChartEditorPart.getChart() == null)	{
+//					page.closeEditor(openedChartEditorPart, false);
+//					return openedChartEditorPart;
+//				}
+				
+				// FIXME: tests with reuseEditor()
+				//openedChartEditorPart  = (ChartEditor) page.reuseEditor(editorPart, editorPart.getEditorInput());
+				
+				
+				//openedChartEditorPart.refreshCorporaView();
+				
+				openedChartEditorPart.forceFocus();
+				
+			}
+			catch(PartInitException e) {
+				e.printStackTrace();
+			}
+			
+		}
+		// get the first installed charts engine that can create chart and use the SWT provider matching it
+		else	{
+			Log.warning("Rendering failed with current charts engine, trying to rendering chart with other installed SWT components provider and other charts engine:");
+	
+			boolean canCreate = false;
+			for(int i = 0; i < ChartsEngine.getChartsEngines().size() && !canCreate; i++) {
+				if(ChartsEngine.getChartsEngines().get(i) != this.chartsEngine)	{
+					ChartsEngine chartsEngine = ChartsEngine.getChartsEngines().get(i);
+					canCreate = chartsEngine.canCreateChart(chartEditorInput.getResult());
+					// get a provider that can manage the charts engine
+					if(canCreate)	{
+						SWTChartsComponentsProvider provider = SWTChartsComponentsProvider.getComponentsProvider(chartsEngine);
+						if(provider != null)	{
+							provider.setChartsEngine(chartsEngine);
+							chartEditorInput.setSWTChartsComponentsProvider(provider);
+							Log.warning(provider.toString());
+							return provider.openEditor(chartEditorInput, editorPartId);
+						}
+					}
+				}
+			}
+		}
+		
+		return openedChartEditorPart;
+	}
+	
+	/**
+	 * 
+	 * @param titleImage
+	 * @param editorInputName
+	 * @param result
+	 * @param chartType
+	 * @param params
+	 * @return
+	 */
+	public ChartEditor openEditor(ChartResult result)	{
+		return this.openEditor(this.createChartEditorInput(result), result.getClass().getName());
+	}
+	
+	
+	/**
+	 * Initializes the default context menus.
+	 * @param composite
+	 */
+	public static void initDefaultContextMenus(ChartComposite composite)	{
+		if(composite != null)	{
+			composite.initItemAreaContextMenu();
+			composite.initEmptyAreaContextMenu();
+			composite.setCurrentContextMenu(EventCallBack.AREA_EMPTY);
+		}
+	}
+
+	
+	/**
+	 * Gets the current active chart editor managing the multi pages editor.
+	 * @param event
+	 * @return
+	 */
+	public static ChartEditor getActiveChartEditor(ExecutionEvent event)	{
+		ChartEditor chartEditor = null;
+
+		Event eevent = (Event)event.getTrigger();
+		Widget widget = eevent.widget;
+		// Toolbars
+		if(event != null && widget instanceof ToolItem)	{
+			ToolItem to = (ToolItem) widget;
+			ToolBar parent = to.getParent();
+			if(to.getParent() instanceof ChartEditorToolBar)	{
+				chartEditor = ((ChartEditorToolBar)((ToolItem)((Event)event.getTrigger()).widget).getParent()).getEditorPart();	
+			}
+			if(to.getParent() instanceof AdvancedChartEditorToolBar)	{
+				chartEditor = ((AdvancedChartEditorToolBar)((ToolItem)((Event)event.getTrigger()).widget).getParent()).getEditorPart();
+			}
+		}
+		// Context menu, multi pages editor
+		else if(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart() instanceof SplitedGenericMultiPageEditor)	{
+			// Main editor
+			if(((SplitedGenericMultiPageEditor) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart()).getMainEditorPart() instanceof ChartEditor
+					&& ((ChartEditor)((SplitedGenericMultiPageEditor) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart()).getMainEditorPart()).hasFocus())	{
+				chartEditor = (ChartEditor)((SplitedGenericMultiPageEditor) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart()).getMainEditorPart();
+			}
+			else if(((MultiPageEditorPart) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActiveEditor()).getSelectedPage() instanceof ChartEditor
+					&& ((ChartEditor)((MultiPageEditorPart) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActiveEditor()).getSelectedPage()).hasFocus() )	{
+				chartEditor = (ChartEditor)((MultiPageEditorPart) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActiveEditor()).getSelectedPage();
+			}
+		}
+		// Context menu, Normal editor
+		else if(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart() instanceof ChartEditor)	{
+			chartEditor = (ChartEditor) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart();	
+		}
+		return chartEditor;
+	}
+	
+	/**
+	 * Initializes AWT default events to delegate AWT events to SWT.
+	 * @param chartEditor
+	 * @param swingComponent
+	 */
+	public static void initializeAWTDelegationListeners(final ChartEditor chartEditor, final JComponent swingComponent)	{
+
+		// AWT to  SWT
+		swingComponent.addMouseMotionListener(new MouseMotionListener() {
+
+			@Override
+			public void mouseMoved(final MouseEvent e) {
+				chartEditor.getComposite().getDisplay().asyncExec(new Runnable () {
+					public void run() {
+						if(!chartEditor.getComposite().isDisposed())	{
+							chartEditor.getComposite().notifyListeners(SWT.MouseMove, SWTChartsComponentsProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.MouseMove));
+						}
+					}
+				});
+			}
+
+			@Override
+			public void mouseDragged(MouseEvent e) {
+				// TODO Auto-generated method stub
+
+			}
+		});
+
+		swingComponent.addMouseListener(new MouseListener() {
+
+			@Override
+			public void mouseReleased(final MouseEvent e) {
+				chartEditor.getComposite().getDisplay().asyncExec(new Runnable () {
+					public void run() {
+						
+						// FIXME: context menu
+						if(e.isPopupTrigger())	{
+
+							//System.err.println("SWTChartsComponentsProvider.initializeAWTDelegationListeners(...).new MouseListener() {...}.mouseReleased(...).new Runnable() {...}.run(): AWT popup trigger detected");
+							
+
+							
+							// update the mouse over item selection according to the mouse event
+							chartEditor.getComposite().getChartComponent().updateMouseOverItem(e);
+							
+							// manually pop up the menu
+							if(chartEditor.getComposite().getMenu() != null)	{
+								chartEditor.getComposite().getMenu().setLocation(new Point(e.getXOnScreen(), e.getYOnScreen()));
+								chartEditor.getComposite().getMenu().setVisible(true);
+							}
+
+							// FIXME: the SWT.MenuDetect event delegation doesn't work, it would be better than manually pop up the menu (but other problem is the dynamic menu on chart entity item)
+							//chartEditor.getComposite().notifyListeners(SWT.MenuDetect, SWTChartsComponentProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.MenuDetect));
+							// FIXME: try to delegate the Menu detect event, DOES NOT SEEM TO WORK
+							//chartEditor.getComposite().notifyListeners(SWT.MenuDetect, SWTChartsComponentsProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.MenuDetect));
+							//chartEditor.getComposite().notifyListeners(SWT.Show, SWTChartsComponentsProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.Show));
+							
+						}
+						chartEditor.getComposite().notifyListeners(SWT.MouseUp, SWTChartsComponentsProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.MouseUp));
+						//chartEditor.activate();
+					}
+				});
+			}
+
+			@Override
+			public void mousePressed(final MouseEvent e) {
+
+				// SWT thread
+				chartEditor.getComposite().getDisplay().asyncExec(new Runnable() {
+					@Override
+					public void run() {
+
+						chartEditor.getComposite().notifyListeners(SWT.MouseDown, SWTChartsComponentsProvider.swingEventToSWT(chartEditor.getComposite(), swingComponent, e, SWT.MouseDown));
+						
+						// FIXME: Debug
+//						System.out.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new MouseListener() {...}.mousePressed(...).new Runnable() {...}.run()");
+						// Activate the editor part on AWT mouse pressed event
+						chartEditor.activate();
+//						chartEditor.forceFocus();
+					}
+				});
+
+			}
+
+			@Override
+			public void mouseExited(java.awt.event.MouseEvent e) {
+				// TODO Auto-generated method stub
+
+			}
+
+			@Override
+			public void mouseEntered(java.awt.event.MouseEvent e) {
+
+				// TODO: DEbug
+				//System.err.println("SWTChartsComponentProvider.initializeSwingDelegationListeners(...) AWT mouse entered");
+
+				// Force the focus in the component on mouse enter
+				/*if(!swingComponent.isFocusOwner())	{
+
+					// SWT thread
+					if(!chartEditor.getComposite().isDisposed())	{
+						chartEditor.getComposite().getDisplay().asyncExec(new Runnable() {
+							public void run() {
+	
+	
+								// FIXME: this code works on Windows and Linux but activate() the chart editor when mouse enters
+								//chartEditor.activate();
+	
+								EventQueue.invokeLater(new Runnable () {
+									public void run () {
+								
+										// TODO: this code forces to give the focus to the embedded AWT Frame under Windows (#1127 related)
+										// For unknown reason Frame.requestFocusInWindow() doesn't work and always return false here
+										// This code is not sufficient for Linux
+										System.out.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...) trying to give focus to root embedded frame");
+										try {
+											Frame frame = (Frame) swingComponent.getFocusCycleRootAncestor();
+											//frame.synthesizeWindowActivation(true);
+											Class clazz = frame.getClass();
+											Method method = clazz.getMethod("synthesizeWindowActivation", new Class[]{boolean.class});
+											if(method != null)	{
+												method.invoke(frame, new Object[]{new Boolean(true)});
+												System.out.println("SWTChartsComponentProvider.initializeSwingDelegationListeners(...).new MouseListener() {...}.mouseEntered(...).new Runnable() {...}.run(): " + frame);
+			
+											}
+			
+											//frame.requestFocusInWindow();
+			
+			                            }
+										catch (Throwable e) {
+											Log.printStackTrace(e);
+										}
+									}
+								});
+								
+								
+								//System.out.println("SWTChartsComponentProvider.initializeSwingDelegationListeners) AWT give focus to frame = " + ((JFCComposite)chartEditor.getComposite()).frame.requestFocusInWindow());
+	
+	
+	//							chartEditor.setFocus();
+	//							System.out.println("SWTChartsComponentProvider.initializeSwingDelegationListeners() SWT got focus = " + chartEditor.getComposite().setFocus());
+	
+	//							EventQueue.invokeLater(new Runnable () {
+	//								public void run () {
+										//swingComponent.requestFocusInWindow();
+	
+	//									System.out.println("SWTChartsComponentProvider.initializeSwingDelegationListeners() AWT got focus = " + swingComponent.requestFocusInWindow());
+	//								}
+	//							});
+	
+	
+	
+							}
+						});
+					}
+				}*/
+			}
+
+			@Override
+			public void mouseClicked(java.awt.event.MouseEvent e) {
+				// TODO Auto-generated method stub
+
+			}
+		});
+
+
+
+
+		// SWT
+
+		// SWT Tooltips tests
+
+
+//		toolTip = new DefaultToolTip(this, org.eclipse.jface.window.ToolTip.RECREATE, true);
+//		toolTip.setPopupDelay(500);
+
+
+
+		// FIXME: test HTML
+//		toolTip = new ___CustomHTMLToolTip(this, org.eclipse.jface.window.ToolTip.NO_RECREATE, true);
+//		toolTip.setShift(new Point(10, 50));
+
+
+
+
+		// Define AWT events, needed to properly give the focus to the Swing component and manage the mouse events
+		Listener listener;
+
+		//FIXME: useless ?
+		// Run event queue dispose event
+//		listener = new Listener () {
+//			 public void handleEvent (Event e) {
+//			   switch (e.type) {
+//					case SWT.Dispose:
+//						chartPanel.getParent().setVisible(false);
+//						EventQueue.invokeLater(new Runnable () {
+//						public void run() {
+//							((Frame) chartPanel.getParent().getParent()).dispose();
+//						}
+//					});
+//				   break;
+//			   }
+//		   }
+//		};
+//		this.addListener(SWT.Dispose, listener);
+
+
+		// Handle the AWT/Swing events delegation
+		listener = new Listener () {
+			public void handleEvent (Event e) {
+				switch (e.type) {
+					case SWT.FocusIn:
+						// FIXME: DEbug
+//						System.out.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT composite gained focus");
+						chartEditor.getComposite().requestFocusInComposite();
+						break;
+					case SWT.MouseMove:
+						//System.err.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT mouse move: " + e.x + " : " + e.y);
+
+//						// FIXME: SWT tool tips test
+//						ToolTip tip = new ToolTip(getShell(), SWT.BALLOON | SWT.ID_HIDE);
+//						tip.setMessage("test tool tip SWT");
+//						tip.setLocation(getDisplay().map(self, null, new Point(e.x, e.y)));
+//						tip.setVisible(true);
+
+//						// FIXME: JFace tool tips test
+//						//DefaultToolTip tip2 = new DefaultToolTip( self, SWT.NONE, true );
+//						//toolTip.setShift(new Point(e.x, e.y));
+//						//toolTip.setText("<html><body><p>rtrt <font style=\"color: red\">yuyuyu</font></p></body></html>");
+//						toolTip.setText(e.text);
+//						if(e.text != null)	{
+//							toolTip.show(new Point(e.x, e.y));
+//						}
+//						else	{
+//							toolTip.hide();
+//						}
+
+						// FIXME: JFace tool tips test 2
+//						toolTip.setText(e.text);
+//						if(e.text != null)	{
+//							toolTip.show(new Point(e.x, e.y));
+//						}
+//						else	{
+//							toolTip.hide();
+//						}
+
+
+
+						break;
+					case SWT.MouseDown:
+						// FIXME: to test in Linux and Mac, it should fix the focus bugs in CA chart between table focus and chart composite/panel focus + Linux singular values bar plot focus bug
+						//System.err.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT mouse down : set focus in composite and request focus in chart panel");
+						chartEditor.getComposite().setFocus();
+						chartEditor.getComposite().requestFocusInComposite();
+						break;
+					case SWT.MouseUp:
+						//System.err.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT mouse up");
+						break;
+
+					case SWT.MouseEnter:
+						//System.err.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT mouse enter");
+						break;
+
+
+					case SWT.Activate:
+						//System.err.println("SWTChartsComponentProvider.initializeAWTDelegationListeners(...).new Listener() {...}.handleEvent(): SWT activate");
+						chartEditor.getComposite().requestFocusInComposite();
+						break;
+				}
+		   }
+		};
+		chartEditor.getComposite().addListener(SWT.FocusIn, listener);
+		chartEditor.getComposite().addListener(SWT.MouseDown, listener); // needed to manage the focus delegation between SWT and AWT/Swing
+
+//		chartEditor.getComposite().addListener(SWT.MouseEnter, listener); // TODO : test AWT delegation
+	//	chartEditor.getComposite().addListener(SWT.Activate, listener); // TODO : test AWT delegation
+
+
+		// FIXME: For Swing focus debug
+		swingComponent.addFocusListener(new FocusListener() {
+			
+			@Override
+			public void focusLost(FocusEvent e) {
+				// TODO Auto-generated method stub
+				swingComponent.setBorder(javax.swing.BorderFactory.createEmptyBorder());
+				Display.getDefault().asyncExec(new Runnable() {
+					
+					@Override
+					public void run() {
+						// TODO Auto-generated method stub
+						chartEditor.deactivateContext();						
+					}
+				});
+			}
+			
+			@Override
+			public void focusGained(FocusEvent e) {
+				// TODO Auto-generated method stub
+				swingComponent.setBorder(new LineBorder(Color.red, 1));
+				
+				Display.getDefault().asyncExec(new Runnable() {
+					
+					@Override
+					public void run() {
+						// TODO Auto-generated method stub
+						chartEditor.activateContext();						
+					}
+				});
+			}
+		});
+		
+
+		// FIXME: SWT tool tips test rather than using Swing
+		//chartEditor.getComposite().addListener(SWT.MouseMove, listener);
+	//	chartEditor.getComposite().addListener(SWT.MouseUp, listener);
+
+
+
+	}
+
+	/**
+	 * Converts an AWT event to SWT event. Also stores the Swing tool tip source text of the specified Swing component in the SWT event to give it to the SWT composite listener in <code>ChartComposite</code>.
+	 * @param swtComposite
+	 * @param swingComponent
+	 * @param e
+	 * @param eventType
+	 * @return
+	 */
+	// TODO : this method is incomplete
+	public static org.eclipse.swt.widgets.Event swingEventToSWT(Composite swtComposite, JComponent swingComponent, MouseEvent e, int eventType)	{
+
+		Event event = new Event();
+		event.button = e.getButton();
+		if(!swtComposite.isDisposed())	{
+			event.display = swtComposite.getDisplay();
+		}
+		event.widget = swtComposite;
+		event.type = eventType;
+
+		try {
+			// Store the Swing tool tip source text in the SWT event to give it to the SWT composite listener in ChartComposite
+			// NOTE: this method call sometimes throws a java.lang.IndexOutOfBoundsException
+			event.text = swingComponent.getToolTipText(e);
+		}
+		catch(Exception e1) {
+			//e1.printStackTrace();
+		}
+		event.x = e.getX();
+		event.y = e.getY();
+		return event;
+	}
+
+	
+
+	@Override
+	public String toString() {
+		String str = this.name + " ("; //$NON-NLS-1$
+		str += "supported input formats: " + this.supportedInputFormats.toString().replaceAll("\\[|\\]", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		str += ", Charts Engine: " + this.chartsEngine + ")"; //$NON-NLS-1$ //$NON-NLS-2$
+		return str;
+	}
+
+
+	/**
+	 * @param name the name to set
+	 */
+	public void setName(String name) {
+		this.name = name;
+	}
+
+
+
+}
\ No newline at end of file
